/*********************************************
  Autor: Marlon Nardi Walendorff
  Projeto: Compressor de ar feito com Arduino - Compressino
  Detalhes do projeto: https://marlonnardi.com/2022/07/13/compressor-de-ar-feito-em-casa-de-baixo-custo-com-arduino-compressino/
  /**********************************************/


//==================== Variáveis Globais ==================//
uint8_t inicial_refresh_display = 0;
uint8_t max_pressure_printed = 0;
uint8_t min_pressure_printed = 0;
uint8_t current_pressure_printed = 0;
uint8_t temperature_motor_printed = 0;
uint8_t cursor_position_printed = 0;

extern volatile uint8_t error_over_temperature_motor;
extern uint8_t error_sensor_pressure_disconected;
extern uint8_t error_motor_stay_off;
extern uint8_t error_motor_stay_on;
extern uint8_t error_sensor_pressure_wrong;

void refreshDisplay(uint8_t max_pressure, uint8_t min_pressure, uint8_t current_pressure, uint8_t temperature_motor, uint8_t cursor_position)
{
    
//------------------------- Erros -----------------------------//   
    if(error_over_temperature_motor)
    {
    digitalWrite(pin_Display_Light ,LOW);
    display.setRotation(0);
    display.clearDisplay();
    display.setTextColor(BLACK);

    display.setTextSize(1);
    //         Comprimento Altura
    display.setCursor(0,17); 
    display.print("ERROR:OVER TEMPERATURE MOTOR"); 
    display.display();  
    }


    if(error_sensor_pressure_disconected)
    {
    digitalWrite(pin_Display_Light ,LOW);
    display.setRotation(0);
    display.clearDisplay();
    display.setTextColor(BLACK);

    display.setTextSize(1);
    //         Comprimento Altura
    display.setCursor(0,17); 
    display.print("ERROR:PRESSURE SENSOR DISCONECTED"); 
    display.display();  
    }


    if(error_motor_stay_off)
    {
    digitalWrite(pin_Display_Light ,LOW);
    display.setRotation(0);
    display.clearDisplay();
    display.setTextColor(BLACK);

    display.setTextSize(1);
    //         Comprimento Altura
    display.setCursor(0,2); 
    display.print("ERROR: MOTOR STAY OFF: PLEASE FIX IT AND RESET"); 
    display.display();  
    }

     if(error_motor_stay_on)
    {
    digitalWrite(pin_Display_Light ,LOW);
    display.setRotation(0);
    display.clearDisplay();
    display.setTextColor(BLACK);

    display.setTextSize(1);
    //         Comprimento Altura
    display.setCursor(0,2); 
    display.print("ERROR: MOTOR STAY ON: PLEASE FIX IT AND RESET"); 
    display.display();  
    }
    
    if(error_sensor_pressure_wrong)
    {
    digitalWrite(pin_Display_Light ,LOW);
    display.setRotation(0);
    display.clearDisplay();
    display.setTextColor(BLACK);

    display.setTextSize(1);
    //         Comprimento Altura
    display.setCursor(0,2); 
    display.print("ERROR: WRONG READ PRESSURE SENSOR: FIX AND RESET"); 
    display.display();  
    }
       
    
    
    if(error_over_temperature_motor == 0 && error_sensor_pressure_disconected == 0 && error_motor_stay_on == 0  && error_motor_stay_off == 0 && error_sensor_pressure_wrong == 0)
    {
//------------------------- Livre de erros -----------------------------// 
    //Atualiza o display somente quando a informação mudar, assim outras partes do código são excecutadas mais rápido.  
    if((max_pressure != max_pressure_printed) || (min_pressure != min_pressure_printed) || (current_pressure != current_pressure_printed) || (temperature_motor != temperature_motor_printed) || (cursor_position != cursor_position_printed) || inicial_refresh_display == 0)
    {   
      
    digitalWrite(pin_Display_Light ,LOW);
    display.setRotation(0);
    display.clearDisplay();
    display.setTextColor(BLACK);
    //--------------- Interface Grafica ------------------------//  
    //---------------- Temperatura Motor
    display.setTextSize(1);
    //         Comprimento Altura
    display.setCursor(0,31); 
    display.print("Motor"); 
    //         Comprimento Altura
    display.setTextSize(1);
    display.setCursor(4,41); 
    display.print(temperature_motor); 
    
    
     
    //----------------- Organização simbolo °C
    if(temperature_motor <10)
    {
    //         Comprimento Altura
    display.setTextSize(1);
    display.setCursor(14,41); 
    display.print("C");
    //                 X    Y  R
    display.drawCircle(11, 42, 1, BLACK);
    }

    if(temperature_motor >=10 && temperature_motor <=99)
    {
    //         Comprimento Altura
    display.setTextSize(1);
    display.setCursor(20,41); 
    display.print("C");
    //                 X    Y  R
    display.drawCircle(17, 42, 1, BLACK);
    }

    if(temperature_motor >=100)
    {
    //         Comprimento Altura
    display.setTextSize(1);
    display.setCursor(26,41); 
    display.print("C");
    //                 X    Y  R
    display.drawCircle(23, 42, 1, BLACK);
    }


    //------------------ Ajuste PSI
    //         Comprimento Altura
    display.setCursor(60,0); 
    display.print("MAX:");

    //         Comprimento Altura
    display.setCursor(62,10); 
    display.print(max_pressure); 
    
    
    display.setTextSize(1);
    //         Comprimento Altura
    display.setCursor(60,25); 
    display.print("MIN:"); 

    //         Comprimento Altura
    display.setCursor(62,35); 
    display.print(min_pressure); 




    //------------------ Reservatório
    //                    X, Y, W, H, RADIUS, COLOR 
    display.drawRoundRect(2,2,20,27,3, BLACK);
    
    display.setRotation(0);

    //         Comprimento Altura
    display.setCursor(25,2); 
    display.print("PSI:");
    
    //         Comprimento Altura
    display.setCursor(25,10); 
    display.print(current_pressure); 

    
    if(current_pressure <= max_pressure)
    {
    display.setRotation(2);
    //                    X, Y, W, H, RADIUS, COLOR
    display.fillRoundRect(62,20,20,map(current_pressure, 0, max_pressure, 3, 26),3, BLACK);
    
    display.setRotation(0);
    //         Comprimento Altura
    display.setCursor(25,22); 
    display.print(map(current_pressure, 0, max_pressure, 0, 100)); 
    }

    if(current_pressure > max_pressure)
    {
    display.setRotation(2);
    //                    X, Y, W, H, RADIUS, COLOR
    display.fillRoundRect(62,20,20,26,3, BLACK);
    display.setRotation(0);
    //         Comprimento Altura
    display.setCursor(25,22); 
    display.print(100); 
    }

    //------------------- Organização simbolo %
    if(current_pressure < max_pressure)
    {
      if(map(current_pressure, 0, max_pressure, 0, 100) <10)
      {
      //         Comprimento Altura
      display.setCursor(31,22); 
      display.print("%");
      }

     if(map(current_pressure, 0, max_pressure, 0, 100) >=10 && map(current_pressure, 0, 120, 0, 100) <=99)
      {
      //         Comprimento Altura
      display.setCursor(37,22); 
      display.print("%");
      }

      if(map(current_pressure, 0, 120, 0, 100) >=100)
      {
      //         Comprimento Altura
      display.setCursor(43,22); 
      display.print("%");
      }
    }


    if(current_pressure >= max_pressure)
    {   
      //         Comprimento Altura
      display.setCursor(43,22); 
      display.print("%");
    }
  


    //------------------- Seta de mudança de valores
    if(cursor_position == 1)
    {  
    //         Comprimento Altura
    display.drawPixel(58,13,BLACK);

    display.drawPixel(57,12,BLACK);
    display.drawPixel(57,13,BLACK);
    display.drawPixel(57,14,BLACK);
    //         Comprimento Altura
    display.drawPixel(56,11,BLACK);
    display.drawPixel(56,12,BLACK);    
    display.drawPixel(56,13,BLACK);
    display.drawPixel(56,14,BLACK);
    display.drawPixel(56,15,BLACK);
    //         Comprimento Altura
    display.drawPixel(55,10,BLACK);
    display.drawPixel(55,11,BLACK);    
    display.drawPixel(55,12,BLACK);
    display.drawPixel(55,13,BLACK);
    display.drawPixel(55,14,BLACK);
    display.drawPixel(55,15,BLACK);
    display.drawPixel(55,16,BLACK);    
    }


    //------------------- Seta de mudança de valores
    if(cursor_position == 2)
    {  
    //         Comprimento Altura
    display.drawPixel(58,38,BLACK);

    display.drawPixel(57,37,BLACK);
    display.drawPixel(57,38,BLACK);
    display.drawPixel(57,39,BLACK);
    //         Comprimento Altura
    display.drawPixel(56,36,BLACK);
    display.drawPixel(56,37,BLACK);    
    display.drawPixel(56,38,BLACK);
    display.drawPixel(56,39,BLACK);
    display.drawPixel(56,40,BLACK);
    //         Comprimento Altura
    display.drawPixel(55,35,BLACK);
    display.drawPixel(55,36,BLACK);    
    display.drawPixel(55,37,BLACK);
    display.drawPixel(55,38,BLACK);
    display.drawPixel(55,39,BLACK);
    display.drawPixel(55,40,BLACK);
    display.drawPixel(55,41,BLACK);    
    }


    
    
    
    
    display.display();

    inicial_refresh_display = 1;
    max_pressure_printed = max_pressure;
    min_pressure_printed = min_pressure;
    current_pressure_printed = current_pressure;
    temperature_motor_printed = temperature_motor;
    cursor_position_printed = cursor_position;
    
    }

}
    
 }//----------end_refreshDisplay
