/*********************************************
  Autor: Marlon Nardi Walendorff
  Projeto: Compressor de ar feito com Arduino - Compressino
  Detalhes do projeto:https://marlonnardi.com/2022/07/13/compressor-de-ar-feito-em-casa-de-baixo-custo-com-arduino-compressino/
  /**********************************************/


#define max_max_pressure_adjust_possible 120
#define min_max_pressure_adjust_possible 10

#define min_min_pressure_adjust_possible 5

#define min_pressure_diferential 5


//==================== Variáveis Globais ==================//
byte aux = 0;
byte aux2 = 0;
byte aux3 = 0;
byte aux_eeprom = 0;
byte menu_Position = 0;
uint8_t max_pressure = 10;  
uint8_t min_pressure = 5;  


extern uint8_t error_sensor_pressure_disconected;
extern volatile uint8_t error_over_temperature_motor;
extern uint8_t error_motor_stay_off;
extern uint8_t error_motor_stay_on;
extern uint8_t error_sensor_pressure_wrong;

void readEncoderAndMenu()
{

//---------------------if_verfificarErro-------------------//
    if(!error_over_temperature_motor && !error_sensor_pressure_disconected && !error_motor_stay_off && !error_motor_stay_on && !error_sensor_pressure_wrong)
    {

EncoderOne.getPosition(); //Captura o valor do encoder

//----------------------- Muda a posição do menu -----------------//
  if (!digitalRead(pin_Encoder_SW)) //Se o botão foi pressionado
  {
    aux = 1;
  }

  if (digitalRead(pin_Encoder_SW) && aux == 1 )//Se o botão está solto
  {
    menu_Position++;
    aux = 0;
  }

  if(menu_Position >2)
  {
   aux_eeprom = 1;
   menu_Position = 0; 
   aux2 = 0;
   aux3 = 0;
  }

  

//------------------ Limita valores de pressão MAX --------------//
  if (EncoderOne.getPosition() <= min_max_pressure_adjust_possible && menu_Position == 1)
  {
    EncoderOne.setPosition(min_max_pressure_adjust_possible);
   
  }

  if (EncoderOne.getPosition() > max_max_pressure_adjust_possible && menu_Position == 1)
  {
    EncoderOne.setPosition(max_max_pressure_adjust_possible);
  }


//------------------ Limita valores de pressão MIN --------------//
  if (EncoderOne.getPosition() <= min_min_pressure_adjust_possible && menu_Position == 2)
  {
    EncoderOne.setPosition(min_min_pressure_adjust_possible);
   
  }

  if (EncoderOne.getPosition() > (max_pressure - min_pressure_diferential) && menu_Position == 2)
  {
    EncoderOne.setPosition(max_pressure - min_pressure_diferential);
  } 



//------------------ Configura valores de pressão MAX e MIN --------------//
  if (menu_Position == 1)
  {  
    if(aux2 == 0)
    {
     EncoderOne.setPosition(max_pressure);
     aux2 = 1;  
    }
     
     max_pressure = EncoderOne.getPosition();
  }

  if (menu_Position == 2)
  {
        if(aux3 == 0)
    {
     EncoderOne.setPosition(min_pressure);
     aux3 = 1;  
    }
     min_pressure = EncoderOne.getPosition();
  }

 

    }//--------End_if_verfificarErro
}//----------End_readEncoder


//================== ISRs Interrupções Externas =======================//
/* Caso qualquer pino do encoder envie sinal, o metodo .tick() sempre será
  chamado, atualizando o valor do encoder via sua biblioteca. */

void ISR0()// Função ligada a uma interrupção ISR logo não pode retornar valor e deve ser mais rápida possível
{
  if(!error_over_temperature_motor && !error_sensor_pressure_disconected && !error_motor_stay_off && !error_motor_stay_on && !error_sensor_pressure_wrong) EncoderOne.tick(); // Começa a ler o valor do encoder

}//----------EndISR0

void ISR1()// Função ligada a uma interrupção ISR logo não pode retornar valor e deve ser mais rápida possível
{
 if(!error_over_temperature_motor && !error_sensor_pressure_disconected && !error_motor_stay_off && !error_motor_stay_on && !error_sensor_pressure_wrong) EncoderOne.tick(); // Começa a ler o valor do encoder
}//----------EndISR1
