/*********************************************
  Autor: Marlon Nardi Walendorff
  Projeto: Compressor de ar feito com Arduino - Compressino
  Detalhes do projeto: https://marlonnardi.com/2022/07/13/compressor-de-ar-feito-em-casa-de-baixo-custo-com-arduino-compressino/
  /**********************************************/


// 190 Dados = 0 PSI 370 Dados = 25 PSIs 490 Dados = 50 PSIs  541 Dados = 60 PSIs  606 Dados = 70 PSIs 661 Dados = 80 PSIs 
//730 Dados = 90  PSIs  790 Dados 100 PSIs 838 Dados = 110 PSIs 892 Dados = 120 PSIs 
#define offsetcurrent_pressure_sensor 190
#define number_average 50

uint16_t average_current_pressure_sensor = 0;
uint16_t current_pressure_sensor_PSI = 0;
uint16_t sum_value_read_current_pressure_sensor = 0;
extern volatile uint16_t time6_in_tenths_of_a_seconds_verify_pressure_sensor;
extern volatile uint16_t time7_in_tenths_of_a_seconds_read_pressure_sensor;

uint16_t static average_read [number_average];

uint8_t error_sensor_pressure_disconected = 0;
uint8_t initial_current_pressure_sensor_PSI = 0;

uint8_t error_sensor_pressure_wrong = 0;

//                      Linhas Colunas
uint16_t table_pressure [10][2] = { 
//Dados, PSI
//0   1
{190, 0},//  0 
{370, 25},// 1 
{490, 50},// 2 
{541, 60},// 3 
{606, 70},// 4
{661, 80},// 5
{730, 90},// 6
{790, 100},//7
{838, 110},//8
{892, 120}// 9
  
};




void readPressure()
{

//--------------------- Média de leituras -------------------//
for( uint8_t i = 0; i < number_average; i++)
{
average_read[i] = analogRead(pin_Pressure_Sensor) - offsetcurrent_pressure_sensor;
sum_value_read_current_pressure_sensor = sum_value_read_current_pressure_sensor + average_read[i];
}


average_current_pressure_sensor = sum_value_read_current_pressure_sensor / number_average;

//-------------------- Erro sensor não detectado -----------------//
if(analogRead(pin_Pressure_Sensor) <= 100)
{
error_sensor_pressure_disconected = 1; 
}
else{
error_sensor_pressure_disconected = 0; 
}


//-------------------- 1º Linha ---------------------//
//                                        Linhas Colunas
if(average_current_pressure_sensor <= (table_pressure [1][0] - offsetcurrent_pressure_sensor) )
{
current_pressure_sensor_PSI = map(average_current_pressure_sensor, table_pressure [0][0] - offsetcurrent_pressure_sensor, table_pressure [1][0] - offsetcurrent_pressure_sensor , table_pressure [0][1], table_pressure [1][1]);
}

//-------------------- 2º Linha ---------------------//
//                                        Linhas Colunas
if(average_current_pressure_sensor > (table_pressure [1][0] - offsetcurrent_pressure_sensor) && average_current_pressure_sensor <= (table_pressure [2][0] - offsetcurrent_pressure_sensor))
{
current_pressure_sensor_PSI = map(average_current_pressure_sensor, table_pressure [1][0] - offsetcurrent_pressure_sensor, table_pressure [2][0] - offsetcurrent_pressure_sensor , table_pressure [1][1], table_pressure [2][1]);
}


//-------------------- 3º Linha ---------------------//
//                                        Linhas Colunas
if(average_current_pressure_sensor > (table_pressure [2][0] - offsetcurrent_pressure_sensor) && average_current_pressure_sensor <= (table_pressure [3][0] - offsetcurrent_pressure_sensor))
{
current_pressure_sensor_PSI = map(average_current_pressure_sensor, table_pressure [2][0] - offsetcurrent_pressure_sensor, table_pressure [3][0] - offsetcurrent_pressure_sensor , table_pressure [2][1], table_pressure [3][1]);
}

//-------------------- 4º Linha ---------------------//
//                                        Linhas Colunas
if(average_current_pressure_sensor > (table_pressure [3][0] - offsetcurrent_pressure_sensor) && average_current_pressure_sensor <= (table_pressure [4][0] - offsetcurrent_pressure_sensor))
{
current_pressure_sensor_PSI = map(average_current_pressure_sensor, table_pressure [3][0] - offsetcurrent_pressure_sensor, table_pressure [4][0] - offsetcurrent_pressure_sensor , table_pressure [3][1], table_pressure [4][1]);
}

//-------------------- 5º Linha ---------------------//
//                                        Linhas Colunas
if(average_current_pressure_sensor > (table_pressure [4][0] - offsetcurrent_pressure_sensor) && average_current_pressure_sensor <= (table_pressure [5][0] - offsetcurrent_pressure_sensor))
{
current_pressure_sensor_PSI = map(average_current_pressure_sensor, table_pressure [4][0] - offsetcurrent_pressure_sensor, table_pressure [5][0] - offsetcurrent_pressure_sensor , table_pressure [4][1], table_pressure [5][1]);
}

//-------------------- 6º Linha ---------------------//
//                                        Linhas Colunas
if(average_current_pressure_sensor > (table_pressure [5][0] - offsetcurrent_pressure_sensor) && average_current_pressure_sensor <= (table_pressure [6][0] - offsetcurrent_pressure_sensor))
{
current_pressure_sensor_PSI = map(average_current_pressure_sensor, table_pressure [5][0] - offsetcurrent_pressure_sensor, table_pressure [6][0] - offsetcurrent_pressure_sensor , table_pressure [5][1], table_pressure [6][1]);
}

//-------------------- 7º Linha ---------------------//
//                                        Linhas Colunas
if(average_current_pressure_sensor > (table_pressure [6][0] - offsetcurrent_pressure_sensor) && average_current_pressure_sensor <= (table_pressure [7][0] - offsetcurrent_pressure_sensor))
{
current_pressure_sensor_PSI = map(average_current_pressure_sensor, table_pressure [6][0] - offsetcurrent_pressure_sensor, table_pressure [7][0] - offsetcurrent_pressure_sensor , table_pressure [6][1], table_pressure [7][1]);
}

//-------------------- 8º Linha ---------------------//
//                                        Linhas Colunas
if(average_current_pressure_sensor > (table_pressure [7][0] - offsetcurrent_pressure_sensor) && average_current_pressure_sensor <= (table_pressure [8][0] - offsetcurrent_pressure_sensor))
{
current_pressure_sensor_PSI = map(average_current_pressure_sensor, table_pressure [7][0] - offsetcurrent_pressure_sensor, table_pressure [8][0] - offsetcurrent_pressure_sensor , table_pressure [7][1], table_pressure [8][1]);
}

//-------------------- 9º Linha ---------------------//
//                                        Linhas Colunas
if(average_current_pressure_sensor > (table_pressure [8][0] - offsetcurrent_pressure_sensor) && average_current_pressure_sensor <= (table_pressure [9][0] - offsetcurrent_pressure_sensor))
{
current_pressure_sensor_PSI = map(average_current_pressure_sensor, table_pressure [8][0] - offsetcurrent_pressure_sensor, table_pressure [9][0] - offsetcurrent_pressure_sensor , table_pressure [8][1], table_pressure [9][1]);
}

//-------------------- 9º Linha ---------------------//
//                                        Linhas Colunas
if(average_current_pressure_sensor > (table_pressure [9][0] - offsetcurrent_pressure_sensor))
{
current_pressure_sensor_PSI = 121;
}

sum_value_read_current_pressure_sensor = 0;







//--------------------- Erro leitura que não muda sensor -------------------//
if(time6_in_tenths_of_a_seconds_verify_pressure_sensor >= 0 && time6_in_tenths_of_a_seconds_verify_pressure_sensor <= 4)
{
  initial_current_pressure_sensor_PSI = current_pressure_sensor_PSI;
}


if(time6_in_tenths_of_a_seconds_verify_pressure_sensor >= 500)
{
if(digitalRead(pin_Relay) == 0 &&  initial_current_pressure_sensor_PSI == current_pressure_sensor_PSI)
{
error_sensor_pressure_wrong = 1;
}
 
}




}
